from ti_system import *
from random import *
from ti_draw import *

w,h=get_screen_dim()
use_buffer()

black=(0,0,0)
white=(255,255,255)
red=(255,0,0)
blue=(0,136,255)
cyan=(0,255,255)
yellow=(255,255,0)
green=(0,255,0)
magenta=(255,0,255)
orange=(255,165,0)

colors=[red,yellow,magenta,cyan,orange]

class Point:
  def __init__(self,x,y,color=blue):
    self.x=x
    self.y=y
    self.selected=False
    self.color=color
    self.cluster=0

  def draw(self):
    set_color(self.color)
    fill_circle(self.x,self.y,r)

class Center:
  def __init__(self,x,y,color,id):
    self.x=x
    self.y=y
    self.color=color
    self.id=id

  def draw(self):
    set_color(self.color)
    d=3
    a=1.73205*d
    x=[self.x-a,self.x+a,self.x,self.x-a]
    y=[self.y+d,self.y+d,self.y-2*d,self.y+d]
    fill_poly(x,y)
    set_color(white)
    draw_poly(x,y)

def background(color):
  set_color(color)
  fill_rect(0,0,w,h)

def distance(P,Q):
  return (P.x-Q.x)**2+(P.y-Q.y)**2

def add_del():
  delete=False
  for p in points:
    if distance(p,mouse)<9:
      points.remove(p)
      delete=True
  if not delete:
    points.append(mouse)

def draw_points():
  for p in points:
    p.draw()

def draw_centers():
  for c in centers:
    c.draw()

def make_data():
  global points,mouse
  key=""
  while key not in {"esc","enter"}:
    background(black)
    key=get_key()
    mx,my=get_mouse()
    mouse=Point(mx,my)
    if key=="r":
      points=[]
    if key=="tab":
      add_del()
    for p in points:
      if p.selected:
        p.x,p.y = mx,my
    draw_points()
    paint_buffer()

def random_data(n):
  for i in range(n):
    g=int(r)
    x=randint(g,w-g)
    y=randint(g,h-g)
    points.append(Point(x,y))
  background(black)
  draw_points()
  paint_buffer()

def number_clusters():
  global centers,clusters
  set_color(green)
  draw_text(5,20,"# clusters (2...5):")
  paint_buffer()
  key=" "
  while key not in "2345":
    key=get_key(1)
    if key=="esc":
      return
  clusters=int(key)

def generate_clusters():
  for p in points:
    mn=1000000
    for c in centers:
      d=distance(p,c)
      if d<mn:
        p.color=c.color
        p.cluster=c.id
        mn=d

def choose_centers():
  global centers
  centers=[]
  background(black)
  draw_points()
  paint_buffer()
  i=0
  key=""
  while i<clusters:
    key=get_key()
    mx,my=get_mouse()
    mouse=Center(mx,my,colors[i],i)
    if key=="esc":
      return
    if key=="r":
      centers=[]
      i=0
      background(black)
      draw_points()
      paint_buffer() 
    if key=="center":
      centers.append(mouse)
      i+=1
    draw_centers()
    paint_buffer()

def update_centers():
  for c in centers:
    n,x,y=0,0,0
    for p in points:
      if p.cluster==c.id:
        x+=p.x
        y+=p.y
        n+=1
    if n>0:
      c.x=x/n
      c.y=y/n

def reset():
  for p in points:
    p.color=blue
  background(black)
  draw_points()
  paint_buffer()
  number_clusters()
  choose_centers()

points=[]

r=1
#make_data()
random_data(10000)
number_clusters()
choose_centers()


key=""
while key!="esc":
  background(black)
  draw_points()
  draw_centers()
  paint_buffer()
  key=get_key(1)
  if key=="esc":
    break
  if key=="r":
    reset()
  else:
    generate_clusters()
    background(black)
    draw_points()
    draw_centers()
    paint_buffer()
    key=get_key(1)
    if key=="esc":
      break
    if key=="r":
      reset()
    else:
      update_centers()
